/**
 * 
 */
package de.mcs.tools.sps;

import java.util.List;

import de.mcs.tools.sps.exceptions.WrongProgramSizeException;

/**
 * @author w.klaas
 *
 */
public abstract class AbstractEmulator implements SPSEmulator {

  @Override
  public abstract List<SPSCommand> getCommands();

  @Override
  public abstract int getProgramSize();

  @Override
  public void loadProgram(byte[] program) throws WrongProgramSizeException {
    if (program.length > getProgramSize()) {
      throw new WrongProgramSizeException(
          String.format("the program is to long. Only %d bytes are permitted", getProgramSize()));
    }

  }

  @Override
  public void startProgram(boolean debug) {

  }

  @Override
  public void addCallback(TOutputCallback callback) {

  }

  @Override
  public void nextStep() {

  }

  @Override
  public boolean isActive() {
    return false;
  }

  @Override
  public void stop() {

  }

  @Override
  public TEmulatorInternals getInternals() {
    return null;
  }

}
